// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v3.21.12
// source: user.proto

package user_grpc

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// UsererClient is the client API for Userer service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type UsererClient interface {
	CreateUser(ctx context.Context, in *UserCreateRequest, opts ...grpc.CallOption) (*UserCreateResponse, error)
	UdpateUser(ctx context.Context, in *UserUpdateRequest, opts ...grpc.CallOption) (*UserUpdateResponse, error)
	VerifyEmail(ctx context.Context, in *UserVerifyEmailRequest, opts ...grpc.CallOption) (*UserUpdateResponse, error)
	ChangePassword(ctx context.Context, in *UserPasswordRequest, opts ...grpc.CallOption) (*UserPasswordResponse, error)
	GetUserByEmail(ctx context.Context, in *UserGetByEmailRequest, opts ...grpc.CallOption) (*UserResponse, error)
	GetUserByPhone(ctx context.Context, in *UserGetUserByPhoneRequest, opts ...grpc.CallOption) (*UserResponse, error)
	GetUserByID(ctx context.Context, in *UserGetUserByIDRequest, opts ...grpc.CallOption) (*UserResponse, error)
	GetUsersByID(ctx context.Context, in *UserGetUsersByIDRequest, opts ...grpc.CallOption) (*UsersResponse, error)
}

type usererClient struct {
	cc grpc.ClientConnInterface
}

func NewUsererClient(cc grpc.ClientConnInterface) UsererClient {
	return &usererClient{cc}
}

func (c *usererClient) CreateUser(ctx context.Context, in *UserCreateRequest, opts ...grpc.CallOption) (*UserCreateResponse, error) {
	out := new(UserCreateResponse)
	err := c.cc.Invoke(ctx, "/user_grpc.Userer/CreateUser", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *usererClient) UdpateUser(ctx context.Context, in *UserUpdateRequest, opts ...grpc.CallOption) (*UserUpdateResponse, error) {
	out := new(UserUpdateResponse)
	err := c.cc.Invoke(ctx, "/user_grpc.Userer/UdpateUser", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *usererClient) VerifyEmail(ctx context.Context, in *UserVerifyEmailRequest, opts ...grpc.CallOption) (*UserUpdateResponse, error) {
	out := new(UserUpdateResponse)
	err := c.cc.Invoke(ctx, "/user_grpc.Userer/VerifyEmail", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *usererClient) ChangePassword(ctx context.Context, in *UserPasswordRequest, opts ...grpc.CallOption) (*UserPasswordResponse, error) {
	out := new(UserPasswordResponse)
	err := c.cc.Invoke(ctx, "/user_grpc.Userer/ChangePassword", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *usererClient) GetUserByEmail(ctx context.Context, in *UserGetByEmailRequest, opts ...grpc.CallOption) (*UserResponse, error) {
	out := new(UserResponse)
	err := c.cc.Invoke(ctx, "/user_grpc.Userer/GetUserByEmail", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *usererClient) GetUserByPhone(ctx context.Context, in *UserGetUserByPhoneRequest, opts ...grpc.CallOption) (*UserResponse, error) {
	out := new(UserResponse)
	err := c.cc.Invoke(ctx, "/user_grpc.Userer/GetUserByPhone", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *usererClient) GetUserByID(ctx context.Context, in *UserGetUserByIDRequest, opts ...grpc.CallOption) (*UserResponse, error) {
	out := new(UserResponse)
	err := c.cc.Invoke(ctx, "/user_grpc.Userer/GetUserByID", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *usererClient) GetUsersByID(ctx context.Context, in *UserGetUsersByIDRequest, opts ...grpc.CallOption) (*UsersResponse, error) {
	out := new(UsersResponse)
	err := c.cc.Invoke(ctx, "/user_grpc.Userer/GetUsersByID", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// UsererServer is the server API for Userer service.
// All implementations must embed UnimplementedUsererServer
// for forward compatibility
type UsererServer interface {
	CreateUser(context.Context, *UserCreateRequest) (*UserCreateResponse, error)
	UdpateUser(context.Context, *UserUpdateRequest) (*UserUpdateResponse, error)
	VerifyEmail(context.Context, *UserVerifyEmailRequest) (*UserUpdateResponse, error)
	ChangePassword(context.Context, *UserPasswordRequest) (*UserPasswordResponse, error)
	GetUserByEmail(context.Context, *UserGetByEmailRequest) (*UserResponse, error)
	GetUserByPhone(context.Context, *UserGetUserByPhoneRequest) (*UserResponse, error)
	GetUserByID(context.Context, *UserGetUserByIDRequest) (*UserResponse, error)
	GetUsersByID(context.Context, *UserGetUsersByIDRequest) (*UsersResponse, error)
	mustEmbedUnimplementedUsererServer()
}

// UnimplementedUsererServer must be embedded to have forward compatible implementations.
type UnimplementedUsererServer struct {
}

func (UnimplementedUsererServer) CreateUser(context.Context, *UserCreateRequest) (*UserCreateResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateUser not implemented")
}
func (UnimplementedUsererServer) UdpateUser(context.Context, *UserUpdateRequest) (*UserUpdateResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UdpateUser not implemented")
}
func (UnimplementedUsererServer) VerifyEmail(context.Context, *UserVerifyEmailRequest) (*UserUpdateResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method VerifyEmail not implemented")
}
func (UnimplementedUsererServer) ChangePassword(context.Context, *UserPasswordRequest) (*UserPasswordResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ChangePassword not implemented")
}
func (UnimplementedUsererServer) GetUserByEmail(context.Context, *UserGetByEmailRequest) (*UserResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetUserByEmail not implemented")
}
func (UnimplementedUsererServer) GetUserByPhone(context.Context, *UserGetUserByPhoneRequest) (*UserResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetUserByPhone not implemented")
}
func (UnimplementedUsererServer) GetUserByID(context.Context, *UserGetUserByIDRequest) (*UserResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetUserByID not implemented")
}
func (UnimplementedUsererServer) GetUsersByID(context.Context, *UserGetUsersByIDRequest) (*UsersResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetUsersByID not implemented")
}
func (UnimplementedUsererServer) mustEmbedUnimplementedUsererServer() {}

// UnsafeUsererServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to UsererServer will
// result in compilation errors.
type UnsafeUsererServer interface {
	mustEmbedUnimplementedUsererServer()
}

func RegisterUsererServer(s grpc.ServiceRegistrar, srv UsererServer) {
	s.RegisterService(&Userer_ServiceDesc, srv)
}

func _Userer_CreateUser_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UserCreateRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UsererServer).CreateUser(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/user_grpc.Userer/CreateUser",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UsererServer).CreateUser(ctx, req.(*UserCreateRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Userer_UdpateUser_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UserUpdateRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UsererServer).UdpateUser(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/user_grpc.Userer/UdpateUser",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UsererServer).UdpateUser(ctx, req.(*UserUpdateRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Userer_VerifyEmail_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UserVerifyEmailRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UsererServer).VerifyEmail(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/user_grpc.Userer/VerifyEmail",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UsererServer).VerifyEmail(ctx, req.(*UserVerifyEmailRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Userer_ChangePassword_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UserPasswordRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UsererServer).ChangePassword(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/user_grpc.Userer/ChangePassword",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UsererServer).ChangePassword(ctx, req.(*UserPasswordRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Userer_GetUserByEmail_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UserGetByEmailRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UsererServer).GetUserByEmail(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/user_grpc.Userer/GetUserByEmail",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UsererServer).GetUserByEmail(ctx, req.(*UserGetByEmailRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Userer_GetUserByPhone_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UserGetUserByPhoneRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UsererServer).GetUserByPhone(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/user_grpc.Userer/GetUserByPhone",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UsererServer).GetUserByPhone(ctx, req.(*UserGetUserByPhoneRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Userer_GetUserByID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UserGetUserByIDRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UsererServer).GetUserByID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/user_grpc.Userer/GetUserByID",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UsererServer).GetUserByID(ctx, req.(*UserGetUserByIDRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Userer_GetUsersByID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UserGetUsersByIDRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UsererServer).GetUsersByID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/user_grpc.Userer/GetUsersByID",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UsererServer).GetUsersByID(ctx, req.(*UserGetUsersByIDRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// Userer_ServiceDesc is the grpc.ServiceDesc for Userer service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Userer_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "user_grpc.Userer",
	HandlerType: (*UsererServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "CreateUser",
			Handler:    _Userer_CreateUser_Handler,
		},
		{
			MethodName: "UdpateUser",
			Handler:    _Userer_UdpateUser_Handler,
		},
		{
			MethodName: "VerifyEmail",
			Handler:    _Userer_VerifyEmail_Handler,
		},
		{
			MethodName: "ChangePassword",
			Handler:    _Userer_ChangePassword_Handler,
		},
		{
			MethodName: "GetUserByEmail",
			Handler:    _Userer_GetUserByEmail_Handler,
		},
		{
			MethodName: "GetUserByPhone",
			Handler:    _Userer_GetUserByPhone_Handler,
		},
		{
			MethodName: "GetUserByID",
			Handler:    _Userer_GetUserByID_Handler,
		},
		{
			MethodName: "GetUsersByID",
			Handler:    _Userer_GetUsersByID_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "user.proto",
}
